
#include "BuildBlock.as"
#include "Requirements.as"

const string blocks_property = "blocks";
const string inventory_offset = "inventory offset";

void addCommonBuilderBlocks( BuildBlock[]@ blocks )
{


AddIconToken( "$triangle_wood_block$", "TriangleWood.png", Vec2f(16,16), 0 );
 AddIconToken( "$trap_block2$", "trap_block2.png", Vec2f(16,16), 0 );
  AddIconToken( "$trap_block3$", "trap_block3.png", Vec2f(16,16), 0 );
 AddIconToken( "$trap_block4$", "TrapBlock4.png", Vec2f(16,16), 0 );
  AddIconToken( "$spikes2$", "spikes2.png", Vec2f(16,16), 0 );
   AddIconToken( "$stone_door2$", "1x1StoneDoor2.png", Vec2f(16,16), 0 );
	{   // stone_block
		BuildBlock b( CMap::tile_castle, "stone_block", "$stone_block$",
						"Stone Block\nBasic building block" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 5 );
		blocks.push_back( b );
	}
	{   // back_stone_block
		BuildBlock b( CMap::tile_castle_back, "back_stone_block", "$back_stone_block$",
						"Back Stone Wall\nExtra support" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 1 );
		blocks.push_back( b );
	}
	{   // stone_door
		BuildBlock b( 0, "stone_door", "$stone_door$",
						"Stone Door\nPlace next to walls" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 50 );
		blocks.push_back( b );
	}    

	{   // wood_block
		BuildBlock b( CMap::tile_wood, "wood_block", "$wood_block$",
						"Wood Block\nCheap block\nwatch out for fire!" );
		AddRequirement( b.reqs, "blob", "mat_wood", "Wood", 5 );
		blocks.push_back( b );
	}
	{   // back_wood_block
		BuildBlock b( CMap::tile_wood_back, "back_wood_block", "$back_wood_block$",
						"Back Wood Wall\nCheap extra support" );
		AddRequirement( b.reqs, "blob", "mat_wood", "Wood", 1 );
		blocks.push_back( b );
	}
	{   // wooden_door
		BuildBlock b( 0, "wooden_door", "$wooden_door$",
						"Wooden Door\nPlace next to walls" );
		AddRequirement( b.reqs, "blob", "mat_wood", "Wood", 30 );
		blocks.push_back( b );
	}

	{   // trap
		BuildBlock b( 0, "trap_block", "$trap_block$",
						"Trap Block\nOnly enemies can pass" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 25 );
		blocks.push_back( b );
	}	
	{   // ladder
		BuildBlock b( 0, "ladder", "$ladder$",
						"Ladder\nAnyone can climb it" );
		AddRequirement( b.reqs, "blob", "mat_wood", "Wood", 10 );
		blocks.push_back( b );
	}
	{   // platform
		BuildBlock b( 0, "wooden_platform", "$wooden_platform$",
						"Wooden Platform\nOne way platform" );
		AddRequirement( b.reqs, "blob", "mat_wood", "Wood", 20 );
		blocks.push_back( b );
	}
	
	{   // spikes
		BuildBlock b( 0, "spikes", "$spikes$",
						"Spikes\nPlace on Stone Block\nfor Retracting Trap" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 30 );
		blocks.push_back( b );
	}
	{   // spikes
		BuildBlock b( 0, "spikes2", "$spikes2$",
						"Hidden spikes like normal people do" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 90 );
		blocks.push_back( b );
	}
	{   // trap
		BuildBlock b( 0, "trap_block2", "$trap_block2$",
						"Trap Block\nDisguised as stone block" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 100 );
		blocks.push_back( b );
	}	
	{   // trap
		BuildBlock b( 0, "trap_block3", "$trap_block3$",
						"Trap Block\nDisguised as dirt" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 100 );
		blocks.push_back( b );
	}
	{   // stone_door
		BuildBlock b( 0, "stone_door2", "$stone_door2$",
						"Hidden Door" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 50 );
		blocks.push_back( b );
	}    
	{   
		BuildBlock b( 0, "trap_block4", "$trap_block4$","Triangle Block" );
		AddRequirement( b.reqs, "blob", "mat_stone", "Stone", 10 );
		blocks.push_back( b );
	}

}
